<template>
  <component :is="tag" class="EntryBlock">
    <span class="EntryBlock__Content">{{
      entry.content || t('entry.content')
    }}</span>

    <span class="EntryBlock__StartDate">{{ humanizeDate(entry.start) }}</span>

    <StopWatch
      :now="entry.stop || Now"
      :start="entry.start"
      class="EntryBlock__Duration"
    />

    <div class="EntryBlock__Stop">
      <Button
        v-if="!entry.stop"
        :icon="Icons.entry.stop"
        :title="t('entry.stop')"
        class="Button--outlined"
        @click="stop"
      />

      <span v-if="entry.stop">{{ humanizeDate(entry.stop) }}</span>
    </div>

    <Button
      class="EntryBlock__EditButton Button--outlined"
      :icon="Icons.entry.edit"
      :title="t('entry.edit')"
      @click="edit"
    />
  </component>
</template>

<script lang="ts">
import { defineComponent, inject, PropType } from 'vue'
import { Button, Icon, InputField, StopWatch } from '@/components'
import * as Types from '@/types'
import * as Helpers from '@/helpers'
import { Icons } from '@/Icons'
import { Now } from '@/states'

export default defineComponent({
  name: 'EntryBlock',
  emits: ['stop', 'remove', 'edit'],
  components: { Button, Icon, StopWatch, InputField },
  props: {
    entry: {
      type: Object as PropType<Types.Entry>,
      required: true,
    },
    tag: {
      type: String,
      required: false,
      default: 'div',
    },
  },

  setup() {
    return {
      humanizeDate: Helpers.Entry.humanizeDate,
      Now,
      Icons,
      t: inject('t', (str: unknown) => str),
    }
  },

  methods: {
    /**
     * Stop this entry
     */
    stop() {
      this.$emit('stop', this.entry.id)
    },

    /**
     * Remove this entry
     */
    remove() {
      this.$emit('remove', this.entry.id)
    },

    /**
     * Open a dialog box to edit the entry
     */
    edit() {
      this.$emit('edit', this.entry.id)
    },
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.EntryBlock {
  display: inline-grid;
  grid-template-rows: [main] 1fr [sub] auto;
  grid-template-columns: [main] 1fr [duration] min-content [edit] min-content;
  grid-row-gap: v.$spacing / 2;
  grid-column-gap: v.$spacing;
  align-items: center;
  justify-content: center;
  padding: v.$spacing;

  &__Content {
    grid-row: main;
    grid-column: main;
    padding: 0;
    //noinspection CssInvalidPseudoSelector
    :deep(input) {
      padding-left: 0;
    }
  }

  &__Duration {
    display: inline-flex;
    grid-row: main;
    grid-column: duration;
    align-items: center;
    justify-content: flex-end;
    white-space: pre;
  }

  &__StartDate,
  &__Stop {
    display: inline-flex;
    grid-row: sub;
    grid-column: main;
    align-items: center;
    justify-content: flex-start;
    font-size: 0.8em;
    white-space: pre;
  }

  &__Stop {
    grid-column: duration;
    justify-content: flex-end;
  }

  &__EditButton {
    grid-row: main / span 2;
    grid-column: edit;
    margin: auto;
  }
}
</style>
